<?php

if (!defined('DATALIFEENGINE')) {
  die("Hacking attempt!");
}
class Qcomment_Action_Admin_Configure extends Qcomment_Admin {
  public function __construct() {
  }
  public function Init() {
    switch ($_REQUEST['operation']) {
      case 'update':
        return $this->_updateQcommentConfigure();
        break;
      default:
        return $this->_reviewQcommentConfig();
        break;
    }
  }

  private function _reviewQcommentConfig() {
    require_once QCOMMENT_DIR . '/data/rates.php';
    foreach ($rates as $value) {
      $option['rates'] .= '<option '.(parent::$config['QC']['tarif_id']==$value['id']?'selected=""':'').' value="'.$value['id'].'">'.$value['label'].' '.$value['price'].'. '.$value['count'].'</option>';
     
    }
    foreach ($subjects as $value) {
      $option['subjects'] .= '<option '.(parent::$config['QC']['subjects']==$value['id']?'selected=""':'').' value="'.$value['id'].'">'.$value['label'].'</option>';
     
    }
    # var_dump($option['rates']);
    $option['border'] = array('<table class="table table-bordered table-striped table-configure"><thead><tr><th class="span6">' . parent::$qcomment_lng['lng_8'][0] . '</th><th>' . parent::$qcomment_lng['lng_8'][1] . '</th></tr></thead><tbody>', '</tbody></table>');
    $option['return'] .= $option['border'][0];
    $option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['subjects'][0] . ' (<a href="http://qcomment.ru/page/api#wiki7" target="_blank">' . parent::$qcomment_lng['lng_9']['subjects'][1] . '</a>):</td><td><select name="save[subjects]">'.$option['subjects'].'</select></td></tr>';
    $option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['group_id'][0] . ' (<a href="http://qcomment.ru/user/projectgroup" target="_blank">' . parent::$qcomment_lng['lng_9']['group_id'][1] . '</a>):</td><td><input class="span4" type="text" name="save[group_id]" value="' . intval(parent::$config['QC']['group_id']) . '" autocomplete="off"></td></tr>';
    $option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['language'] . '</td><td>' . parent::makeDropDown(array(
      'ru' => parent::$qcomment_lng['lng_10'][0],
      'ua' => parent::$qcomment_lng['lng_10'][1],
      'by' => parent::$qcomment_lng['lng_10'][2],
      'en' => parent::$qcomment_lng['lng_10'][3]), 'save[language]', parent::$config['QC']['language']) . '</td></tr>';
    $option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['min_rating'] . '</td><td>' . parent::makeDropDown(array(
      '1' => 1,
      '2' => 2,
      '3' => 3,
      '4' => 4,
      '5' => 5), 'save[min_rating]', parent::$config['QC']['min_rating']) . '</td></tr>';
    $option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['team_id'][0] . ' (<a href="http://qcomment.ru/user/teams" target="_blank">' . parent::$qcomment_lng['lng_9']['team_id'][1] . '</a>):</td><td><input class="span4" type="text" name="save[team_id]" value="' . intval(parent::$config['QC']['team_id']) . '" autocomplete="off"></td></tr>';
    $option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['comment_configs'][0] . '</td><td>
    <label class="checkbox "><input ' . (in_array(0, parent::$config['QC']['config']) ? 'checked':'') . ' type="checkbox" name="save[config][]" value="0">' . parent::$qcomment_lng['lng_9']['comment_configs'][1] . '</label>
    <label class="checkbox "><input ' . (in_array(1, parent::$config['QC']['config']) ? 'checked':'') . ' type="checkbox" name="save[config][]" value="1">' . parent::$qcomment_lng['lng_9']['comment_configs'][2] . '</label>
    <label class="checkbox "><input ' . (in_array(2, parent::$config['QC']['config']) ? 'checked':'') . ' type="checkbox" name="save[config][]" value="2">' . parent::$qcomment_lng['lng_9']['comment_configs'][3] . '</label>
    <label class="checkbox "><input ' . (in_array(3, parent::$config['QC']['config']) ? 'checked':'') . ' type="checkbox" name="save[config][]" value="3">' . parent::$qcomment_lng['lng_9']['comment_configs'][4] . '</label>
    <label class="checkbox "><input ' . (in_array(4, parent::$config['QC']['config']) ? 'checked':'') . ' type="checkbox" name="save[config][]" value="4">' . parent::$qcomment_lng['lng_9']['comment_configs'][5] . '</label>
    <label class="checkbox "><input ' . (in_array(5, parent::$config['QC']['config']) ? 'checked':'') . ' type="checkbox" name="save[config][]" value="5">' . parent::$qcomment_lng['lng_9']['comment_configs'][6] . '</label>
    </td></tr>';
    //config array? no ?
    #var_dump();
    $option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['start_time'] . '</td><td><input class="span3 datepicker" id="start_time" type="text" name="save[start_time]" value="' . parent::$config['QC']['start_time'] . '" autocomplete="off"></td></tr>';
    $option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['end_time'] . '</td><td><input class="span3 datepicker" id="end_time" type="text" name="save[end_time]" value="' . parent::$config['QC']['end_time'] . '" autocomplete="off"></td></tr>';
    $option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['limit'] . '</td><td><input class="span4" type="text" name="save[limit]" value="' . intval(parent::$config['QC']['limit']) . '" autocomplete="off"></td></tr>';
    $option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['min_day_limit'] . '</td><td><input class="span4" type="text" name="save[min_day_limit]" value="' . intval(parent::$config['QC']['min_day_limit']) . '" autocomplete="off"></td></tr>';
    $option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['max_day_limit'] . '</td><td><input class="span4" type="text" name="save[max_day_limit]" value="' . intval(parent::$config['QC']['max_day_limit']) . '" autocomplete="off"></td></tr>';
    $option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['limit_author'] . '</td><td><input class="span4" type="text" name="save[limit_author]" value="' . intval(parent::$config['QC']['limit_author']) . '" autocomplete="off"></td></tr>';
    $option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['limit_author_day'] . '</td><td><input class="span4" type="text" name="save[limit_author_day]" value="' . intval(parent::$config['QC']['limit_author_day']) . '" autocomplete="off"></td></tr>';

    //
    $option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['limit_url'] . '</td><td><input class="span4" type="text" name="save[limit_url]" value="' . intval(parent::$config['QC']['limit_url']) . '" autocomplete="off"></td></tr>';
    $option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['limit_url_day'] . '</td><td><input class="span4" type="text" name="save[limit_url_day]" value="' . intval(parent::$config['QC']['limit_url_day']) . '" autocomplete="off"></td></tr>';
    $option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['limit_hour'] . '</td><td><input class="span4" type="text" name="save[limit_hour]" value="' . intval(parent::$config['QC']['limit_hour']) . '" autocomplete="off"></td></tr>';

    //
    $option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['max_turn'] . '</td><td><input class="span4" type="text" name="save[max_turn]" value="' . intval(parent::$config['QC']['max_turn']) . '" autocomplete="off"></td></tr>';
    $option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['stop_words'] . '</td><td><textarea name="save[stop_words]" class="span4">' . trim(stripslashes(parent::$config['QC']['stop_words'])) . '</textarea></td></tr>';
    $option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['tarif_id'][0] . ' (<a href="http://qcomment.ru/page/api#wiki7" target="_blank">' . parent::$qcomment_lng['lng_9']['tarif_id'][1] . '</a>):</td><td><select name="save[tarif_id]">'.$option['rates'].'</select></td></tr>';
    $option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['bonus'] . '</td><td><input class="span4" type="text" name="save[bonus]" value="' . intval(parent::$config['QC']['bonus']) . '" autocomplete="off"></td></tr>';
    $option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['task'] . '</td><td><textarea name="save[task]" class="span4">' . trim(stripslashes(parent::$config['QC']['task'])) . '</textarea></td></tr>'; //:TODO:
    #$option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['by_new_post'] . '</td><td>' . $d . '</td></tr>';
    $option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['api'] . '</td><td><input class="span4" type="text" name="save[api]" value="' . parent::$config['QC']['api'] . '" autocomplete="off"></td></tr>';
    //
    $option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['pay'] . '</td><td><input class="span4" type="text" name="save[pay]" value="' . parent::$config['QC']['pay'] . '" autocomplete="off"></td></tr>';

    //$option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['send_email'] . '</td><td>' . parent::makeDropDown(array('no' => parent::$qcomment_lng['lng_15'][0], 'yes' => parent::$qcomment_lng['lng_15'][1]), 'save[send_email]', parent::$config['QC']['send_email']) . '</td></tr>';
    $option['return'] .= '<tr><td>' . parent::$qcomment_lng['lng_9']['load_comment_label'] . '</td><td>' . parent::makeDropDown(array('yes' => parent::$qcomment_lng['lng_9']['load_comment'][0], 'no' => parent::$qcomment_lng['lng_9']['load_comment'][1]), 'save[load_comment]', parent::$config['QC']['load_comment']) . '</td></tr>';
    
    #$option['return'] .= '<tr><td>'.parent::$qcomment_lng['lng_9']['moderation'].'</td><td>' . parent::makeDropDown(array('0' => parent::$qcomment_lng['lng_16'][0], '1' =>  parent::$qcomment_lng['lng_16'][1]), 'save[moderation]', parent::$config['QC']['moderation']) . '</td></tr>';
    $option['return'] .= $option['border'][1];

    $option['return'] = '<form action="' . parent::$path . '?mod=qcomment&action=configure" method="post"><fieldset><legend>' . parent::$qcomment_lng['lng_12'] . '</legend>' . $option['return'] . '</fieldset><button class="btn" name="operation" value="update" type="submit">' . parent::$qcomment_lng['lng_11'] . '</button></form>';
    return $option['return'];
  }
  private function _updateQcommentConfigure() {
    $_POST['save_param']['version'] = '1.0';
    $save_con = $_POST['save'];
    $handler = fopen(QCOMMENT_DIR . '/data/config.php', "w");
    fwrite($handler, "<?PHP \n\$qcomment_config = array (\n");
    foreach ($save_con as $name => $value) {
      if (is_array($value)) {
        foreach ($value as &$element) {
          $element = $this->_filterParam($element);
          if (!$element) {
            continue;
          }
          $element = trim($element);
          $element = "'" . $element . "'";
        }
        $value = implode(',', $value);
        fwrite($handler, "'{$name}' => array({$value}),\n");
      } else {
        $value = $this->_filterParam($value);
        fwrite($handler, "'{$name}' => \"{$value}\",\n");
      }
    }
    fwrite($handler, ");\n?>");
    fclose($handler);
    header('Location: ' . parent::$path . '?mod=qcomment&action=configure');
  }
  private function _filterParam($value) {
    $find[] = "'\r'";
    $replace[] = "";
    $find[] = "'\n'";
    $replace[] = "";
    $value = trim(stripslashes($value));
    $value = htmlspecialchars($value, ENT_QUOTES, parent::$config['DLE']['charset']);
    $value = preg_replace($find, $replace, $value);
    $value = str_replace("$", "&#036;", $value);
    $value = str_replace("{", "&#123;", $value);
    $value = str_replace("}", "&#125;", $value);
    return $value;
  }
}

?>