<?php

@error_reporting(E_ALL ^ E_WARNING ^ E_NOTICE);
@ini_set('display_errors', true);
@ini_set('html_errors', false);
@ini_set('error_reporting', E_ALL ^ E_WARNING ^ E_NOTICE);
define('DATALIFEENGINE', true);
define('ROOT_DIR', substr(dirname(__file__), 0, -24));
define('ENGINE_DIR', ROOT_DIR . '/engine');
define('QCOMMENT_DIR', ENGINE_DIR . '/qcomment');
require_once QCOMMENT_DIR . '/data/config.php';
require_once ENGINE_DIR . '/data/config.php';
require_once ENGINE_DIR . '/classes/mysql.php';
require_once ENGINE_DIR . '/data/dbconfig.php';
require_once ENGINE_DIR . '/classes/parse.class.php';
$parse = new ParseFilter();
$parse->safe_mode = true;
$parse->allow_url = false;
$parse->allow_image = false;
$getLast = $db->super_query("SELECT * FROM `" . PREFIX . "_qcomment_log` ORDER BY `last`  ASC LIMIT 1");
if (empty($getLast['last'])) {
  $getLast = $db->super_query("SELECT * FROM `" . PREFIX . "_qcomment` WHERE `status` = 1 ORDER BY `id` DESC");
  $project = (int)$getLast['project_id'];
  if (empty($project)) {
    die();
  }
  $db->query("INSERT INTO `" . PREFIX . "_qcomment_log` (`id`, `last`) VALUES (NULL, '{$project}');");
  $get = $getLast;
} else {
  $get = $db->super_query("SELECT * FROM `" . PREFIX . "_qcomment` WHERE `project_id` < {$getLast['last']} AND `status` = 1 ORDER BY `project_id` DESC LIMIT 1");
  $project = (int)$get['project_id'];
  if (empty($project)) {
    $db->query("TRUNCATE TABLE `" . PREFIX . "_qcomment_log`");
    die();
  }
  $db->query("INSERT INTO `" . PREFIX . "_qcomment_log` (`id`, `last`) VALUES (NULL, '{$project}');");
}
if (!$project) {
  die();
}
function convert_unicode($t, $to = 'windows-1251') {
  $to = strtolower($to);
  if ($to == 'utf-8') {
    return $t;
  } else {
    if (function_exists('mb_convert_encoding')) {
      $t = mb_convert_encoding($t, $to, "UTF-8");
    } elseif (function_exists('iconv')) {
      $t = iconv("UTF-8", $to . "//IGNORE", $t);
    } else
      $t = "The library iconv AND mbstring is not supported by your server";
  }
  return $t;
}
$getUser = $db->query("SELECT email, user_id, name, qcomment_name, logged_ip FROM `" . PREFIX . "_users` WHERE `qcomment_name` != ''");
while ($row = $db->get_row($getUser)) {
  foreach ($row as $key => $value) {
    $user[$row['qcomment_name']][$key] = stripslashes($value);
  }
}
#var_dump();

#die();
$data = array('apicode' => $qcomment_config['api'], 'project_id' => $project);
if ($qcomment_config['load_comment'] != 'yes') {
  $data['status'] = 4;
}
$curlObj = curl_init();
curl_setopt($curlObj, CURLOPT_URL, 'http://qcomment.ru/api/comments');
curl_setopt($curlObj, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($curlObj, CURLOPT_HEADER, 0);
curl_setopt($curlObj, CURLOPT_POST, 1);
curl_setopt($curlObj, CURLOPT_POSTFIELDS, $data);
$result = curl_exec($curlObj);
curl_close($curlObj);
$obj = json_decode($result);
$count = 0;
if ($obj->error_code) {
  die();
}
foreach ($obj as $comment) {
  if ($user[$comment->name]) {
    $row['user'] = array(
      'email' => $user[$comment->name]['email'],
      'user_id' => $user[$comment->name]['user_id'],
      'name' => $user[$comment->name]['name'],
      'logged_ip' => $user[$comment->name]['logged_ip'],
      'is_register' => 1,
      );
  } else {
    $row['user'] = array(
      'email' => '',
      'user_id' => 0,
      'name' => $comment->name,
      'logged_ip' => '127.0.0.1',
      'is_register' => 0,
      );
  }
  $comment->message = trim(convert_unicode($comment->message, $config['charset']));
  $comment->message = $parse->BB_Parse($parse->process($comment->message), false);
  $insert[] = "INSERT INTO `" . PREFIX . "_comments` (`id`, `post_id`, `user_id`, `date`, `autor`, `email`, `text`, `ip`, `is_register`, `approve`) VALUES({$comment->id}, {$get['post']}, {$row['user']['user_id']}, '{$comment->date}', '{$row['user']['name']}', '{$row['user']['email']}', '{$comment->message}', '{$row['user']['logged_ip']}', {$row['user']['is_register']}, 1) ON DUPLICATE KEY UPDATE post_id = {$get['post']};";
  $count++;
}
if (!empty($insert)) {
  $insert[] = "UPDATE `" . PREFIX . "_post` SET `comm_num` = '{$count}' WHERE `id` = {$get['post']} LIMIT 1;";
  foreach ($insert as $queryInsert) {
    $db->query($queryInsert);
  }
}
echo 'ok';

?>